<script type="text/javascript">
  RED.nodes.registerType("dim-conf", {
    category: 'config',
    defaults: {
      host: { value: "", required: true },
      port: { value: RED._('node-red-dim/dimConf:dimConf.default.port'),
        validate: RED.validators.number(true) },
      retry: { value: RED._('node-red-dim/dimConf:dimConf.default.retry'),
        validate: function(r) {
          return ((r === "") || (RED.validators.number(r) && (r >= 1000)));
        }
      }
    },
    inputs: 0,
    outputs: 0,
    label: function() {
      let lbl = this.host + ":";
      lbl += this.port ? this.port :
        this._('node-red-dim/dimConf:dimConf.default.port');
      return lbl;
    }
  });
</script>

<script type="text/html" data-template-name="dim-conf">
  <div class="form-row">
    <label for="node-config-input-host">
      <i class="fa fa-globe"></i>
      <span data-i18n="dimConf.label.host"></span>
    </label>
    <input type="text" id="node-config-input-host" data-i18n="[placeholder]dimConf.default.host">
  </div>
  <div class="form-row">
    <label for="node-config-input-port">
      <span data-i18n="dimConf.label.port"></span>
    </label>
    <input type="text" id="node-config-input-port" data-i18n="[placeholder]dimConf.default.port">
  </div>
  <div class="form-row">
    <label for="node-config-input-retry">
      <i class="fa fa-repeat"></i>
      <span data-i18n="dimConf.label.retry"></span>
    </label>
    <input type="text" id="node-config-input-retry" data-i18n="[placeholder]dimConf.default.retry" style="width:100px;">
    <label for="node-config-input-retry">
      <span data-i18n="dimConf.label.retry-unit"></span>
    </label>
  </div>
</script>

<!-- DIM Nodes' edit dialog template -->
<script id="dim-node-inputs" type="text/x-handlebars-template">
  {{#with nodeName}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}"><i class="fa fa-tag"></i>  {{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim/dimConf:dimConf.placeholder.node-name">
      </div>
    {{/ifDef}}
  {{/with}}
  {{#with nodeConf}}
    {{#ifDef property label}}
      <div class="form-row" data-dim-id="config-node-input">
        <label for="node-input-{{property}}"><i class="fa fa-globe"></i>  {{label}}</label>
        <input type="text" id="node-input-{{property}}">
        <div class="dim-loader" style="display:none;"></div>
      </div>
      <div data-dim-id="config-node-notification-area" style="display:none;"></div>
    {{/ifDef}}
  {{/with}}
  {{#with service}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-dim-id="service-input" data-i18n="[placeholder]node-red-dim/dimConf:dimConf.placeholder.service" list="service-list">
        <datalist id="service-list">
        </datalist>
      </div>
      <div data-dim-id="service-notification-area" style="display:none;"></div>
    {{/ifDef}}
  {{/with}}
  {{#with serviceName}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim/dimConf:dimConf.placeholder.service-name">
      </div>
    {{/ifDef}}
  {{/with}}
  {{#each serviceDefinitions}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" data-i18n="[placeholder]node-red-dim/dimConf:dimConf.placeholder.service-definition" list="serviceDef-list">
        <datalist id="serviceDef-list">
          <option value="C - string">
          <option value="S:1 - int16">
          <option value="I:1 - int32">
          <option value="X:1 - int64">
          <option value="F:1 - float">
          <option value="D:1 - double">
        </datalist>
      </div>
    {{/ifDef}}
  {{/each}}
  {{#each stdInputs}}
    {{#ifDef property label}}
      <div class="form-row">
        <label for="node-input-{{property}}">{{label}}</label>
        <input type="text" id="node-input-{{property}}" placeholder="{{placeholder}}">
      </div>
    {{/ifDef}}
  {{/each}}
</script>

<style>
  .dim-msg-error{
    background-color: #d6615f;
    text-align: center;
    color: white;
    border-radius: 4px;
    padding: 10px;
    position: relative;
    left: 110px;
    display: inline-block;
    margin-bottom: 12px;
  }

  .dim-msg-error::before{
    content: '';
    height: 0px;
    width: 0px;
    border-left: 7px solid transparent;
    border-right: 7px solid transparent;
    border-bottom: 7px solid #d6615f;
    position: absolute;
    top: -7px;
  }

  .form-row .dim-loader{
    display: inline-block;
    position: relative;
    top: 8px;
    left: 4px;
    width: 12px;
    height: 12px;
    border: 4px solid rgb(212, 207, 207);
    border-radius: 50%;
    border-top: 4px solid grey;
    animation: dim-spin 2s linear infinite;
  }

  @keyframes dim-spin {
    0% { transform: rotate(0deg); }
    100% { transform: rotate(360deg); }
  }
</style>

<!-- DIM Nodes' utilities -->
<script type="text/javascript">
  if (!window.dimPromise) {
    const prom = {};
    prom.promise = new Promise((resolve) => (prom.resolve = resolve));
    window.dimPromise = prom;
  }
  const
    dimTemplatesPromise = $.getScript('https://cdnjs.cloudflare.com/ajax/libs/handlebars.js/4.7.6/handlebars.min.js')
    .then(function() {
      Handlebars.registerHelper('ifDef', function(a, b, options) {
        if (a && b && typeof(a) === "string" && typeof(b) === "string") {
          return options.fn(this);
        }
      });

      return Handlebars.compile(
        document.getElementById("dim-node-inputs").innerHTML);
    }),

    dim = {
      utils: {
        genNodeTemplate: async function(nodeType, fields) {
          const template = await dimTemplatesPromise;

          const nodeTemplate = $('script[data-template-name="' + nodeType + '"]');
          nodeTemplate.text(template(fields) + nodeTemplate.text());
        },
        /**
         * @brief retrieve list of services from the selected DNS Server
         * @return {?Promise<Array<{ name:string, definition:string, type:string }>}
         */
         serviceList: function() {
          const confInput = $('div[data-dim-id=config-node-input]')
            .find('select[id|=node-input]');
          const srvInput = $('input[data-dim-id=service-input]');
          const srvNotif = $('div[data-dim-id=service-notification-area]');

          if (confInput.length === 1 && srvInput.length === 1) {
            const confNode = confInput.children('option:selected');
            if (confNode.val() !== '_ADD_') {
              const dnsServer = confNode.text();
              confInput.prop('disabled', true);
              $('.dim-loader').show();

              return $.ajax({
                url: "service-list/" + dnsServer,
                type:"GET",
              })
              .then(
                function(res) { /* success */
                  confInput.prop('disabled', false);
                  $('.dim-loader').hide();

                  return res.list || [];
                },
                function(jqXHR, textStatus, errorThrown) { /* error */
                  confInput.prop('disabled', false);
                  $('.dim-loader').hide();

                  if (jqXHR.status == 500) {
                    srvInput.attr('class', 'input-error');
                    srvNotif.addClass('dim-msg-error')
                    .text(RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.service-list'))
                    .show('fast', function() {
                      srvInput.one('keypress', () => srvNotif.hide('fast'));
                    });
                  }
                  else if (jqXHR.status == 0) {
                    RED.notify(RED._("node-red:common.notification.error",
                      { message: RED._("node-red:common.notification.errors.no-response") }),
                      "error");
                  }
                  else {
                    RED.notify(RED._("node-red:common.notification.error",
                      { message: RED._("node-red:common.notification.errors.unexpected",
                      { status: jqXHR.status, message: textStatus }) }), "error");
                  }
                  return [];
                }
              );
            }
          }
          return null;
        },
        /**
         * @brief initialize the service drop-down list
         * @return {?{
         *  clear: () => void,
         *  append: (Array<string>) => void
         * }}
         */
         initDropDownList: function() {
          const confInput = $('div[data-dim-id=config-node-input]')
            .find('select[id|=node-input]');
          const srvInput = $('input[data-dim-id=service-input]');
          const srvDataList = $('#service-list');

          if (confInput.length === 1 && srvInput.length === 1) {

            const confNotif =
              $('div[data-dim-id=config-node-notification-area]');
            const srvNotif =
              $('div[data-dim-id=service-notification-area]');

            srvInput.focus(function() {
              if (confInput.children('option:selected').val() === '_ADD_') {
                this.setAttribute('class', 'input-error');
                this.readOnly = true;

                confNotif.addClass('dim-msg-error')
                .text(RED._('node-red-dim-xml/dimXmlConf:dimXmlConf.error.dns-server-missing'))
                .show('fast');
              }
            });

            return {
              clear: () => {
                /* notifications and inputs cleanup */
                confNotif.hide('fast');
                srvNotif.hide('fast');
                srvInput.attr('readOnly', false).val('');
                srvDataList.empty();
              },
              append: (srvList) => {
                if (Array.isArray(srvList)) {
                  let services = [];

                  srvList.forEach(s => { services.push($('<option>').val(s)); });
                  srvDataList.append(services);
                }
              }
            }
          }
          return null;
        },
        getSingleValue: function(node) {
          if (node.changed) {
            return RED.notify(RED._("notification.warning",
              { message: RED._("notification.warnings.undeployedChanges") }),
              "warning");
          }

          let nodeLabel = node._def.label.call(node);
          if (nodeLabel.length > 38) {
            nodeLabel = nodeLabel.substring(0, 50) + "...";
          }
          nodeLabel = nodeLabel.replace(/&/g,"&amp;")
            .replace(/</g,"&lt;").replace(/>/g,"&gt;");

          $.ajax({
            url: node.type + "/" + node.id,
            type:"POST",
            success: function(resp) {
              RED.notify(node._('node-red-dim/dicValue:dicValue.success.value-fetched',
                { node: nodeLabel }), { type: "success", id: "dicValue" });
            },
            error: function(jqXHR, textStatus, errorThrown) {
              if (jqXHR.status == 404) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.not-deployed") }),
                  "error");
              }
              else if (jqXHR.status == 500) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._('node-red-dim/dicValue:dicValue.error.fetch-failed') }),
                  "error");
              }
              else if (jqXHR.status == 0) {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.no-response") }),
                  "error");
              }
              else {
                RED.notify(node._("node-red:common.notification.error",
                  { message: node._("node-red:common.notification.errors.unexpected",
                  { status: jqXHR.status, message: textStatus }) }), "error");
              }
            }
          });
        }
      },
      regExp: {
        srvName: "^\\b(?:[A-Za-z0-9][\\w-+.:]*)(?:\\/[A-Za-z0-9][\\w-+.:]*)*$",
        srvDefFormat: "(?:[ICLSFDX]\\:[1-9]\\d*\\;)*[ICLSFDX](?:\\:[1-9]\\d*)?",
      }
    },
    dis = {
      regExp: {
        srvName: new RegExp(dim.regExp.srvName),
        srvDefFormat: new RegExp("^\\b" + dim.regExp.srvDefFormat + "$"),
        srvDefDescr: /\s\-\s(?:string|int16|int32|int64|float|double)/
      }
    },
    dic = {
      regExp: {
        srvName: new RegExp(dim.regExp.srvName),
        srvDefFormat: new RegExp("\\s\\[\\s" + dim.regExp.srvDefFormat + "\\s\\]$"),
        srvDefFormatIO: new RegExp("\\s\\[\\s" + dim.regExp.srvDefFormat + "," +
          dim.regExp.srvDefFormat + "\\s\\]$")
      }
    };
    dimPromise.resolve(dim);
</script>
